"use strict";

exports.__esModule = true;
exports.chunkStepper = chunkStepper;
function chunkStepper(runFn, config) {
  if (typeof runFn !== `function`) {
    throw new Error(`You must pass a function to chunkSteppers first argument`);
  }
  if (!Array.isArray(config) || !config.length) {
    throw new Error(`You must pass an array of objects to chunkSteppers second argument`);
  }
  let currentValues = config[0];
  let counter = 0;
  const tick = () => {
    var _currentValues3;
    if (currentValues && counter++ >= currentValues.until) {
      var _currentValues, _currentValues2;
      currentValues = config[config.indexOf(currentValues) + 1];
      console.log(`changing values to until ${(_currentValues = currentValues) === null || _currentValues === void 0 ? void 0 : _currentValues.until} every ${(_currentValues2 = currentValues) === null || _currentValues2 === void 0 ? void 0 : _currentValues2.every}`);
    }
    if ((_currentValues3 = currentValues) !== null && _currentValues3 !== void 0 && _currentValues3.every && counter % currentValues.every === 0) {
      return runFn(counter);
    }
    return undefined;
  };
  return {
    tick
  };
}
//# sourceMappingURL=chunk-stepper.js.map